#include "MyModel.h"
//---------------------------------------------------------------------------
//
//  Member Function of class MyModel
//
//---------------------------------------------------------------------------
MyModel::MyModel():mode(0),ModelSize(0),NumVertex(0),NumNormal(0),NumFace(0)
{
        Min.x = Min.y = Min.z = Max.x = Max.y = Max.z = 0;
        return;
}
//---------------------------------------------------------------------------
MyModel::~MyModel()
{
        Unload();
        return;
}
//---------------------------------------------------------------------------
//
//  Deal with TRI File
//
//---------------------------------------------------------------------------
bool MyModel::LoadTri(const char* filename)
{
	FILE *infile = NULL;
    int i=0;
	char FirstToken[10] = "";
        char StringBuffer[81] = "";
        bool fail=false;
        int TempFace;
	if((infile = fopen(filename, "r")) == NULL)
		return false;
//Preprocessing Stage
        //Search for "Triangle"
        TempFace = 0;
        while(fgets(StringBuffer,80,infile) != NULL){
                if(strcmpi(StringBuffer,"Triangle\n") == 0)
                        TempFace++;
        }
        //Check if the file is a TRI file
        if(TempFace == 0){
                //MessageBox(NULL,"ɮפL","",MB_OK);
                return false;
        }
        //Clear old data
        Unload();
        //Get file type and size
        ModelSize = filelength(fileno(infile));
        mode = MODEL_TRI;
        //There are 3 Vertex and Normal in 1 Face
        NumFace   = TempFace;
        NumVertex = TempFace * 3;
        NumNormal = TempFace * 3;
        NumPart = 1;
        //Rewind
        fseek(infile, 0L, SEEK_SET);
//Allocate memory
// malloc version
/*
        if((FaceList = (MyFace*)malloc(sizeof(MyFace) * NumFace)) == NULL)
                //MessageBox(NULL,"Fail to allocate memory for Face data","",MB_OK);
        if((VertexList = (MyVector*)malloc(sizeof(MyVector) * NumVertex)) == NULL)
                //MessageBox(NULL,"Fail to allocate memory for Vertex data","",MB_OK);
        if((NormalList = (MyVector*)malloc(sizeof(MyVector) * NumNormal)) == NULL)
                //MessageBox(NULL,"Fail to allocate memory for Normal data","",MB_OK);
*/
// new version
        if((FaceList = new MyFace[NumFace+100]) == NULL)
                MessageBox(NULL,"Fail to allocate memory for Face data","",MB_OK);
        if((VertexList = new MyVector[NumVertex+100]) == NULL)
                MessageBox(NULL,"Fail to allocate memory for Vertex data","",MB_OK);
        if((NormalList = new MyVector[NumNormal+100]) == NULL)
                MessageBox(NULL,"Fail to allocate memory for Normal data","",MB_OK);

//Read Stage
	while(fscanf(infile,"%s",FirstToken) != EOF){
		if(strcmpi(FirstToken,"Triangle") == 0){
//Read Face Data
			if(fscanf(infile,"%u %u %u %u %u %u",&FaceList[i].ForeColor[0],&FaceList[i].ForeColor[1],&FaceList[i].ForeColor[2],&FaceList[i].BackColor[0],&FaceList[i].BackColor[1],&FaceList[i].BackColor[2]) == EOF)
                                fail = true;
			if(fscanf(infile,"%f%f%f%f%f%f",&VertexList[3*i].x,&VertexList[3*i].y,&VertexList[3*i].z,&NormalList[3*i].x,&NormalList[3*i].y,&NormalList[3*i].z) == EOF)
                                fail = true;
			if(fscanf(infile,"%f%f%f%f%f%f",&VertexList[3*i+1].x,&VertexList[3*i+1].y,&VertexList[3*i+1].z,&NormalList[3*i+1].x,&NormalList[3*i+1].y,&NormalList[3*i+1].z) == EOF)
                                fail = true;
			if(fscanf(infile,"%f%f%f%f%f%f",&VertexList[3*i+2].x,&VertexList[3*i+2].y,&VertexList[3*i+2].z,&NormalList[3*i+2].x,&NormalList[3*i+2].y,&NormalList[3*i+2].z) == EOF)
                                fail = true;
                        FaceList[i].VIndex[0] = 3*i;
                        FaceList[i].VIndex[1] = 3*i+1;
                        FaceList[i].VIndex[2] = 3*i+2;
                        FaceList[i].NIndex[0] = 3*i;
                        FaceList[i].NIndex[1] = 3*i+1;
                        FaceList[i].NIndex[2] = 3*i+2;
                        i++;
		}
                else
                        fail = true;
                if(fail){
                        MessageBox(NULL,"~ɮ׮榡ɮפwglI","",MB_OK);
                        Unload();
                        return false;
                }
	}
	fclose(infile);
        return true;
}
//---------------------------------------------------------------------------
bool MyModel::SaveTri(const char* filename)
{
        FILE *outfile;
        if((outfile=fopen(filename,"w")) == NULL){
                MessageBox(NULL,"Lkxsɮ","",MB_OK);
        }
        //gJɮ
        for(int i=0;i<NumFace;i++){
                fprintf(outfile,"Triangle\n");
                fprintf(outfile,"%u %u %u %u %u %u\n",FaceList[i].ForeColor[0],FaceList[i].ForeColor[1],FaceList[i].ForeColor[2],FaceList[i].BackColor[0],FaceList[i].BackColor[1],FaceList[i].BackColor[2]);
                fprintf(outfile,"%f   %f   %f   %f   %f   %f\n",VertexList[FaceList[i].VIndex[0]].x,VertexList[FaceList[i].VIndex[0]].y,VertexList[FaceList[i].VIndex[0]].z,NormalList[FaceList[i].NIndex[0]].x,NormalList[FaceList[i].NIndex[0]].y,NormalList[FaceList[i].NIndex[0]].z);
                fprintf(outfile,"%f   %f   %f   %f   %f   %f\n",VertexList[FaceList[i].VIndex[1]].x,VertexList[FaceList[i].VIndex[1]].y,VertexList[FaceList[i].VIndex[1]].z,NormalList[FaceList[i].NIndex[1]].x,NormalList[FaceList[i].NIndex[1]].y,NormalList[FaceList[i].NIndex[1]].z);
                fprintf(outfile,"%f   %f   %f   %f   %f   %f\n",VertexList[FaceList[i].VIndex[2]].x,VertexList[FaceList[i].VIndex[2]].y,VertexList[FaceList[i].VIndex[2]].z,NormalList[FaceList[i].NIndex[2]].x,NormalList[FaceList[i].NIndex[2]].y,NormalList[FaceList[i].NIndex[2]].z);
        }
        fclose(outfile);
        return true;
}
//---------------------------------------------------------------------------
void MyModel::Stat()
{
        int i;
        Max.x = Max.y = Max.z = Min.x = Min.y = Min.z = 0;
        for(i=0;i<NumVertex;i++){
                if(VertexList[i].x > Max.x)
                        Max.x = VertexList[i].x;
                if(VertexList[i].x < Min.x)
                        Min.x = VertexList[i].x;
                if(VertexList[i].y > Max.y)
                        Max.y = VertexList[i].y;
                if(VertexList[i].y < Min.y)
                        Min.y = VertexList[i].y;
                if(VertexList[i].z > Max.z)
                        Max.z = VertexList[i].z;
                if(VertexList[i].z < Min.z)
                        Min.z = VertexList[i].z;
        }
        Center.x = (Max.x+Min.x)/2;
        Center.y = (Max.y+Min.y)/2;
        Center.z = (Max.z+Min.z)/2;
}
//---------------------------------------------------------------------------
bool MyModel::Unload()
{
        mode = MODEL_NONE;
        NumVertex = 0;
        NumNormal = 0;
        NumFace = 0;
        NumPart = 0;
        ModelSize = 0;
        Min.x = Min.y = Min.z = Max.x = Max.y = Max.z = 0;
        // free version
        /*
                if(FaceList != NULL){
                        free((VERTEX*)FaceList);
                        FaceList = NULL;
                }
                if(VertexList != NULL){
                        free((VERTEX*)VertexList);
                        VertexList = NULL;
                }
                if(NormalList != NULL){
                        free((VERTEX*)NormalList);
                        NormalList = NULL;
                }
        */
        // delete version
                if(FaceList != NULL){
                        delete[] FaceList;
                        FaceList = NULL;
                }
                if(VertexList != NULL){
                        delete[] VertexList;
                        VertexList = NULL;
                }
                if(NormalList != NULL){
                        delete[] NormalList;
                        NormalList = NULL;
                }

        return true;
}
